/*
 *	intr.c		FDN Digital Temperature meter for FD3S
 *				Version 1.0 2003(c) Kashi Electronics Designs,
 *				H.Kashima, All Rights Reserved.
 *				PIC18F252 with compiler HiTech-C
 */
#include <pic18.h>
#include "sys.h"
#include "disp.h"
#include "ecu.h"

char		c_sec;
short		s_min;
unsigned char		uc_tmr25;				/* 25ms timer */
unsigned char		uc_blink;
unsigned char		uc_btnmsk;
unsigned char		uc_button = 0x38;
unsigned char		uc_comitval;

void interrupt	intr()
{
	if(CCP1IF){							/* CCP1 detected TMR1 == 32768 */
		CCP1IF = 0;
		if(++c_sec >= 60){
			if( ++s_min >= 720 )
				s_min = 0;
			c_sec = 0;
		}
	}

	if(TMR0IF){							/* Timer0 1.5KHz(every 667us) */
		TMR0IF = 0;

//		TMR0H = 0xfc;						/* reload Timer0, 0x10000 - 833(1.5KHz) */
//		TMR0L = 0xbf;
		TMR0H = 0xfa;						/* reload Timer0, 0x10000 - 833(1.5KHz) */
		TMR0L = 0xcb;

		if(--c_cntTEN == 0){				/* TEN line 20Hz for diagnosis activate */
			c_cntTEN = 35;
			uc_tmr25++;					/* incriment 25ms universal timer */
			uc_comitval++;
			uc_commTO++;

			if( (c_comstate == COMS_WAITQUERY ||
			     c_comstate == COMS_ERROR )
				&& uc_commTO > 39){		/* timeout wait query 1sec */
				c_sbufp = 0; c_rbufp = 0;
				c_comstate = COMS_SENDING;
				TXIE = 1; RCIE = 1;		/* restart start transmit */
			}
			if( uc_btnmsk > 0 )			/* decriment button mask counter */
				uc_btnmsk--;

			if( uc_blink > 0 )			/* disp blink timer */
				uc_blink--;

			if(b_actTEN){
				if(OUT_TENFB)
					OUT_TEN = 0;
				else
					OUT_TEN = 1;
			} else
				OUT_TEN = 0;

			uc_button = PORTB & 0x38;	/* button sampling every 25ms */
			if( uc_button == 0x38 )	/* clear mask if button released */
				uc_btnmsk = 0;

		}
		C5920_send();					/* transfer LED bit data, every 667us */
	}

	if(RCIF & RCIE) uart_recv();
	if(TXIF & TXIE) uart_send();

}

unsigned char		uc_button, uc_btnmsk;

unsigned char		getbtn()
{
	if( uc_btnmsk )
		return 0;

	return	~(uc_button | 0xc7);
}
