/*
 *	mapmon.c	FDN Digital Temperature meter for FD3S
 *				Version 1.0 2003(c) Kashi Electronics Designs,
 *				H.Kashima, All Rights Reserved.
 *				PIC18F252 with compiler HiTech-C
 */
#include <pic18.h>
#include "ecu.h"
#include "sys.h"
#include "intr.h"
#include "disp.h"

char		md_MapDisp( char next, char enter )
{
	char		i, p, c_titled;
	unsigned char		hist[8], decay[8];
	unsigned char		rpm, pres, injp, injs;
	unsigned char		btn, b_captured, b_cmd;

	uc_tmr25 = 0;								/* 25ms timer */
	uc_comitval = 0;
	b_captured = 0;
	b_cmd = 0; c_titled = 0;
	p = 0;									/* decay pointer */
	pres = 0; rpm = 0;
	for(i = 0; i < 4; i++){
		hist[i] = 0;
		decay[i] = 0;
	}
	disp_cls();
	disp_kanji(K16_MAP);

	while(1){
		if( SW_IGON == 0)
			break;

		btn = getbtn();
		if( btn & BTN_DOWN ){
			uc_btnmsk = BTNMSKTIME;					/* disable button pushed still 200ms */
			return next;

		} else if( btn & BTN_UP ){						/* display hold/reset */
			uc_btnmsk = BTNMSKTIME;


		} else if( btn & BTN_SET ){
			uc_btnmsk = BTNMSKTIME;
			return enter;
		}

		if(!c_titled && uc_tmr25 > CMDWAIT){
			disp_cls();
			disp_banner( 8, 24, (TEXT)"MapTracer");
			c_titled = 1;

		} else if( uc_tmr25 > CMDWAIT && !b_cmd) {
			if( c_comstate == COMS_DONE )
				c_comstate = COMS_READY;
			if(ecu_mon4( ECU16_IPRESSw, ECU16_ESPEEDw,
				  ECU16_INJPw, ECU16_INJSw))
				  continue;

			b_cmd = 1;
			uc_comitval = 0;

		} else if( uc_comitval > 5 && b_cmd ){	 		/* 150ms interval */
			if(ecu_reexec())
				continue;

			uc_comitval = 0;

		} else if(c_comstate == COMS_DONE && b_cmd && !c_bnrstrp){
			if( uc_datas[0] > 1)
				pres = uc_datas[0] - 2;
			else
				pres = 0;

			if( pres > 12)
				pres = 12;

			if( uc_datas[1] > 0)
				rpm = uc_datas[1] - 1;
			else
				rpm = 0;

			if( rpm > 10 )
				rpm = 10;

			injp = uc_datas[2] * 2;
			if( injp > 15 )
				injp = 15;

			injs = uc_datas[3] * 2;
			if( injs > 15 )
				injs = 15;
			c_comstate = COMS_READY;				/* got datas */

			hist[p] = rpm << 4 | pres;
			decay[p] = 8;
			if( ++p > 7 )
				p = 0;

			for(i = 0; i < 8; i++){
				if( decay[i] > 0 )
					if( --decay[i] == 0)					/* clear older dot */
						disp_dot( hist[i] & 0x0f, hist[i] >> 4, 0);
			}
			disp_dot( pres, rpm, 1);						/* draw trace */
			for(i = 0; i < 16; i++){						/* draw pri.injector graph */
				if( i <= injp )
					disp_dot( 14, 15 - i, 1);
				else
					disp_dot( 14, 15 - i, 0);
			}
			for(i = 0; i < 16; i++){						/* draw sec.injector graph */
				if( i <= injs )
					disp_dot( 15, 15 - i, 1);
				else
					disp_dot( 15, 15 - i, 0);
			}
			b_captured = 1;
		}
	}

	return M_MAPDISP;
}
